Mass cleanup and some bug fixing
[snf-image] / snf-image-host / create
1 #!/bin/bash
2
3 # Copyright 2011 GRNET S.A. All rights reserved.
4 #
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions
7 # are met:
8 #
9 #   1. Redistributions of source code must retain the above copyright
10 #      notice, this list of conditions and the following disclaimer.
11 #
12 #  2. Redistributions in binary form must reproduce the above copyright
13 #     notice, this list of conditions and the following disclaimer in the
14 #     documentation and/or other materials provided with the distribution.
15 #
16 # THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
17 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
19 # ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
20 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
21 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
22 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
23 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
24 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
25 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
26 # SUCH DAMAGE.
27 #
28 # The views and conclusions contained in the software and documentation are
29 # those of the authors and should not be interpreted as representing official
30 # policies, either expressed or implied, of GRNET S.A.
31
32 set -e
33 set -o pipefail
34
35 . common.sh
36
37 ganeti_os_main
38
39 case "$IMAGE_TYPE" in
40     extdump)
41         image_file="$IMAGE_DIR/$IMAGE_NAME-$ARCH.extdump";;
42     ntfsdump)
43         image_file="$IMAGE_DIR/$IMAGE_NAME-$ARCH.ntfsdump";;
44     *)
45         log_error "Unknown image type: \`$IMAGE_TYPE'.";
46         exit 1
47 esac
48
49 if [ ! -e "$image_file" ]; then
50     log_error "Image file \`$image_file' does not exit."
51     exit 1
52 fi
53
54 monitor="" #Empty if progress monitor support is disabled
55 if [ "$progress_monitor_support" = "yes" ]; then
56     image_size="$(stat -L -c %s "$IMAGE_FILE")"
57     monitor="$(printf "%q" "$PROGRESS_MONITOR") \
58         -i $(printf "%q" "$INSTANCE_NAME") -r $image_size"
59 fi
60
61 # If the target device is not a real block device we'll first losetup it.
62 # This is needed for file disks.
63 if [ ! -b "$blockdev" ]; then
64     original_blockdev="$blockdev"
65     blockdev=$("$LOSETUP" -sf "$blockdev")
66     add_cleanup "$LOSETUP" -d "$blockdev"
67 fi
68
69 format_disk0 "$blockdev" "$IMAGE_TYPE"
70
71 filesystem_dev=$(map_disk0 "$blockdev")
72 add_cleanup unmap_disk0 "$blockdev"
73
74 root_dev="${filesystem_dev}-1"
75
76 # dd the dump to its new home :-)
77 # Deploying an image file on a target block device is a streaming
78 # copy operation. Enable the direct I/O flag on the output fd to 
79 # avoid polluting the host cache with useless data.
80 $monitor dd bs=4M if="$IMAGE_FILE" of="$root_dev" oflag=direct
81
82 # Create a floppy image
83 floppy=$(mktemp --tmpdir floppy.XXXXXX)
84 add_cleanup rm "$floppy"
85
86 snf_export_DEV=/dev/vda
87 snf_export_TYPE="$IMG_FORMAT"
88 snf_export_PASSWORD="$IMG_PASSWD"
89 snf_export_HOSTNAME="$instance"
90 if [ -n "$IMG_PERSONALITY" ]; then
91     snf_export_PERSONALITY="$IMG_PERSONALITY"
92 fi
93
94 create_floppy "$floppy"
95
96 # Invoke the helper vm to do the dirty job...
97 result_file=$(mktemp --tmpdir result.XXXXXX)
98 add_cleanup rm "$result_file"
99
100 snapshot=$(mktemp --tmpdir helperXXXXXX.img)
101 add_cleanup rm "$snapshot"
102
103 "$QEMU_IMG" create -f qcow2 -b "$HELPER_IMG" "$snapshot"
104
105 "$TIMELIMIT" -t "$HELPER_SOFT_TIMEOUT" -T "$HELPER_HARD_TIMEOUT" \
106     kvm -runas "$HELPER_USER" -drive file="$snapshot" \
107     -drive file="$root_dev",format=raw,if=virtio,cache=none \
108     -boot c -serial stdio -serial file:"$result_file" \
109     -fda "$floppy" -vga none -nographic -parallel none -monitor null \
110     -kernel "$HELPER_KERNEL" -initrd "$HELPER_INITRD" \
111     -append "quiet ro root=/dev/sda1 console=ttyS0,9600n8" \
112     2>&1 | sed 's|^|HELPER: |g'
113
114 if [ $? -ne 0 ]; then
115     if [ $? -gt 128 ];  then
116         log_error "Helper was terminated. Did not finish on time."
117     fi
118     exit 1
119 fi
120
121 # Read the first line. This will remove \r and \n chars
122 result=$(sed 's|\r||g' "$result_file" | xargs echo)
123
124 if [ "x$result" != "xSUCCESS" ]; then
125     log_error "Helper VM returned error"
126     exit 1
127 fi
128
129 # Install a new MBR
130 "$INSTALL_MBR" -p 1 -i n "$blockdev"
131
132 # Execute cleanups
133 cleanup
134 trap - EXIT
135
136 exit 0
137
138 # vim: set sta sts=4 shiftwidth=4 sw=4 et ai :